/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * Contact Information:
 * Swarco Traffic Systems GmbH
 * Entwicklung
 * Adolf-Dambach-Strae
 * D-76571 Gaggenau
 * Phone: +49 (0)7225-64-0
 * Fax: +49 (0)7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.ste.stealgsba.algorithmen.lib;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.ResultData;

/**
 * Kommentar 
 *
 * @version $Revision: 1.3 $ / $Date: 2015/09/02 12:50:04 $ / ($Author: Asal $)
 *
 * @author Swarco Traffic Systems GmbH
 * @author Rolf Asal
 *
 */
public class StaukriteriumErgebnis
{
	private StaukriteriumWerte m_staukriterium1;
	private StaukriteriumWerte m_staukriterium2;
	private StaukriteriumWerte m_staukriterium3;
	private StaukriteriumWerte m_staukriterium4;
	private StaukriteriumWerte m_staukriterium5;
	private StaukriteriumWerte m_staukriterium6;
	
	/**
	 * Default-Konstruktor ohne weitere Funktion.
	 */
	public StaukriteriumErgebnis()
	{		
	}
	
	/**
	 * Konstruktor mit bernahme der Daten.
	 * @param rdata zu bernehmender Datensatz.
	 */
	public StaukriteriumErgebnis(ResultData rdata)
	{
		if (rdata != null)
		{
			if (rdata.hasData())
			{
				Data data = rdata.getData();
				
				if (m_staukriterium1 == null)
					m_staukriterium1 = new StaukriteriumWerte(data.getItem("Staukriterium1"));
				else
					m_staukriterium1.setDaten(data.getItem("Staukriterium1"));

				if (m_staukriterium2 == null)
					m_staukriterium2 = new StaukriteriumWerte(data.getItem("Staukriterium2"));
				else
					m_staukriterium2.setDaten(data.getItem("Staukriterium2"));

				if (m_staukriterium3 == null)
					m_staukriterium3 = new StaukriteriumWerte(data.getItem("Staukriterium3"));
				else
					m_staukriterium3.setDaten(data.getItem("Staukriterium3"));

				if (m_staukriterium4 == null)
					m_staukriterium4 = new StaukriteriumWerte(data.getItem("Staukriterium4"));
				else
					m_staukriterium4.setDaten(data.getItem("Staukriterium4"));

				if (m_staukriterium5 == null)
					m_staukriterium5 = new StaukriteriumWerte(data.getItem("Staukriterium5"));
				else
					m_staukriterium5.setDaten(data.getItem("Staukriterium5"));

				if (m_staukriterium6 == null)
					m_staukriterium6 = new StaukriteriumWerte(data.getItem("Staukriterium6"));
				else
					m_staukriterium6.setDaten(data.getItem("Staukriterium6"));
			}
		}
	}
	
	/**
	 * @return the staukriterium1
	 */
	public StaukriteriumWerte getStaukriterium1()
	{
		return m_staukriterium1;
	}

	/**
	 * @param staukriterium1 the staukriterium1 to set
	 */
	public void setStaukriterium1(StaukriteriumWerte staukriterium1)
	{
		m_staukriterium1 = staukriterium1;
	}

	public boolean isStaukriterium1Stau()
	{
		if (m_staukriterium1 != null)
		{
			if (m_staukriterium1.getZStau() > m_staukriterium1.getZNichtStau())
				return true;
		}
		return false;
	}
	/**
	 * @return the staukriterium2
	 */
	public StaukriteriumWerte getStaukriterium2()
	{
		return m_staukriterium2;
	}

	/**
	 * @param staukriterium2 the staukriterium2 to set
	 */
	public void setStaukriterium2(StaukriteriumWerte staukriterium2)
	{
		m_staukriterium2 = staukriterium2;
	}

	/**
	 * @return the staukriterium3
	 */
	public StaukriteriumWerte getStaukriterium3()
	{
		return m_staukriterium3;
	}

	/**
	 * @param staukriterium3 the staukriterium3 to set
	 */
	public void setStaukriterium3(StaukriteriumWerte staukriterium3)
	{
		m_staukriterium3 = staukriterium3;
	}

	/**
	 * @return the staukriterium4
	 */
	public StaukriteriumWerte getStaukriterium4()
	{
		return m_staukriterium4;
	}

	/**
	 * @param staukriterium4 the staukriterium4 to set
	 */
	public void setStaukriterium4(StaukriteriumWerte staukriterium4)
	{
		m_staukriterium4 = staukriterium4;
	}

	/**
	 * @return the staukriterium5
	 */
	public StaukriteriumWerte getStaukriterium5()
	{
		return m_staukriterium5;
	}

	/**
	 * @param staukriterium5 the staukriterium5 to set
	 */
	public void setStaukriterium5(StaukriteriumWerte staukriterium5)
	{
		m_staukriterium5 = staukriterium5;
	}

	/**
	 * Kommentar 
	 *
	 * @version $Revision: 1.3 $ / $Date: 2015/09/02 12:50:04 $ / ($Author: Asal $)
	 *
	 * @author Swarco Traffic Systems GmbH
	 * @author Rolf Asal
	 *
	 */
	public class StaukriteriumWerte
	{
		private float m_zNichtStau;
		private float m_zStau;
		private float m_vNichtStau;
		private float m_vStau;
		private float m_gNichtStau;
		private float m_gStau;
		
		/**
		 * Default-Konstruktor ohne weitere Funktion.
		 */
		public StaukriteriumWerte()
		{			
		}
		
		/**
		 * Konstruktor mit bernahme der Daten.
		 * @param daten zu bernehmender Datensatz.
		 */
		public StaukriteriumWerte(Data daten)
		{
			setDaten(daten);
		}
		
		/**
		 * bernahme der bergebenen Daten in die interne Struktur.
		 * @param daten zu bernehmender Datensatz.
		 */
		public void setDaten(Data daten)
		{
			if (daten != null)
			{
				m_vNichtStau = daten.getItem("Nicht-Stau").getScaledValue("Vertrauenswrdigkeit").floatValue();
				m_vStau = daten.getItem("Stau").getScaledValue("Vertrauenswrdigkeit").floatValue();

				m_zNichtStau = daten.getItem("Nicht-Stau").getScaledValue("Zugehrigkeit").floatValue();
				m_zStau = daten.getItem("Stau").getScaledValue("Zugehrigkeit").floatValue();

				m_gNichtStau = daten.getItem("Nicht-Stau").getScaledValue("Gte").floatValue();
				m_gStau = daten.getItem("Stau").getScaledValue("Gte").floatValue();
			}
		}

		/**
		 * @return the zNichtStau
		 */
		public float getZNichtStau()
		{
			return m_zNichtStau;
		}

		/**
		 * @param nichtStau the zNichtStau to set
		 */
		public void setZNichtStau(float nichtStau)
		{
			m_zNichtStau = nichtStau;
		}

		/**
		 * @return the zStau
		 */
		public float getZStau()
		{
			return m_zStau;
		}

		/**
		 * @param stau the zStau to set
		 */
		public void setZStau(float stau)
		{
			m_zStau = stau;
		}

		/**
		 * @return the vNichtStau
		 */
		public float getVNichtStau()
		{
			return m_vNichtStau;
		}

		/**
		 * @param nichtStau the vNichtStau to set
		 */
		public void setVNichtStau(float nichtStau)
		{
			m_vNichtStau = nichtStau;
		}

		/**
		 * @return the vStau
		 */
		public float getVStau()
		{
			return m_vStau;
		}

		/**
		 * @param stau the vStau to set
		 */
		public void setVStau(float stau)
		{
			m_vStau = stau;
		}

		/**
		 * @return the gNichtStau
		 */
		public float getGNichtStau()
		{
			return m_gNichtStau;
		}

		/**
		 * @param nichtStau the gNichtStau to set
		 */
		public void setGNichtStau(float nichtStau)
		{
			m_gNichtStau = nichtStau;
		}

		/**
		 * @return the gStau
		 */
		public float getGStau()
		{
			return m_gStau;
		}

		/**
		 * @param stau the gStau to set
		 */
		public void setGStau(float stau)
		{
			m_gStau = stau;
		}
	}

	/**
	 * Gibt den Wert der Variable m_staukriterium6 zurck.
	 *
	 * @return Wert der Variable m_staukriterium6.
	 */
	public StaukriteriumWerte getStaukriterium6()
	{
		return m_staukriterium6;
	}

	/**
	 * Setzt den Wert der Variable m_staukriterium6.
	 *
	 * @param staukriterium6 zu setzender Wert der Variable m_staukriterium6.
	 */
	public void setStaukriterium6(StaukriteriumWerte staukriterium6)
	{
		m_staukriterium6 = staukriterium6;
	}

}
